// OpenGLView.cpp : implementation of the COpenGLView class
//

#include "stdafx.h"
#include "Transform.h"

#include "TransformDoc.h"
#include "TransformView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpenGLView

IMPLEMENT_DYNCREATE(COpenGLView, CView)

BEGIN_MESSAGE_MAP(COpenGLView, CView)
	//{{AFX_MSG_MAP(COpenGLView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpenGLView construction/destruction

COpenGLView::COpenGLView()
{
}

COpenGLView::~COpenGLView()
{
}

BOOL COpenGLView::PreCreateWindow(CREATESTRUCT& cs)
{
  // OpenGL    WS_CLIPCHILDREN  WS_CLIPSIBLINGS
  cs.style |= (WS_CLIPCHILDREN | WS_CLIPSIBLINGS);

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// COpenGLView printing

BOOL COpenGLView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void COpenGLView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void COpenGLView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

/////////////////////////////////////////////////////////////////////////////
// COpenGLView diagnostics

#ifdef _DEBUG
void COpenGLView::AssertValid() const
{
	CView::AssertValid();
}

void COpenGLView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDocument* COpenGLView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDocument)));
	return (CDocument*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COpenGLView message handlers

int COpenGLView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
//    
  m_pDC = new CClientDC(this);
  ASSERT(m_pDC != NULL);

//    
  HDC hdc = m_pDC->GetSafeHdc();

//   
	if (SetPixelFormat(hdc)==FALSE)
		return -1;

//      
	if (CreateGLContext(hdc)==FALSE)
		return -1;
  
	return 0;
}

void COpenGLView::OnDestroy() 
{
  //    
  HGLRC	hrc = ::wglGetCurrentContext();

//       
  ::wglMakeCurrent(NULL,  NULL);

//   
  if (hrc)
    ::wglDeleteContext(hrc);

//    
  if (m_pDC)
    delete m_pDC;

	CView::OnDestroy();
}

BOOL COpenGLView::SetPixelFormat(HDC hdc)
{
 //   
  static PIXELFORMATDESCRIPTOR pfd = 	{
    sizeof(PIXELFORMATDESCRIPTOR),  //  
    1,                              //  
    PFD_DRAW_TO_WINDOW   |          //    
    PFD_SUPPORT_OPENGL   |          //  OpenGL
    PFD_DOUBLEBUFFER,               //  
    PFD_TYPE_RGBA,         //    RGBA
    24,                    // 24-  
    0, 0, 0, 0, 0, 0,      //   
    0,                     //    
    0,                     //   
    0,                     //    
    0, 0, 0, 0,            //   
    32,                    // 32-  
    0,                     //    
    0,                     //    
    PFD_MAIN_PLANE,        //  
    0,                     // 
    0, 0, 0                //   
  };
  
  int pixelFormat;
  
//      ?
  if((pixelFormat = ::ChoosePixelFormat(hdc, &pfd)) == 0){
    MessageBox("     ");
    return FALSE;
  }

  if (::SetPixelFormat(hdc, pixelFormat, &pfd) == FALSE)
    {
      MessageBox("   SetPixelFormat");
      return FALSE;
    }

  return TRUE;
}

BOOL COpenGLView::CreateGLContext(HDC hdc)
{
  HGLRC		hrc;

//   
  if((hrc = ::wglCreateContext(hdc)) == NULL)
    return FALSE;

//    
  if(::wglMakeCurrent(hdc, hrc) == FALSE)
    return FALSE;

  return TRUE;
}

void COpenGLView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);

  //    
  m_width  = (GLint)cx/2;
  m_height = (GLint)cy;
}

/////////////////////////////////////////////////////////////////////////////
// COpenGLView drawing

void COpenGLView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
}
